'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nodeSqlparser = require('node-sqlparser');

var _es6Promise = require('es6-promise');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _ = require('../../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Sql = function () {
  function Sql() {
    _classCallCheck(this, Sql);
  }

  _createClass(Sql, null, [{
    key: 'cleanRequest',
    value: function cleanRequest(str, jsonPage) {
      var matchFrom = /from .(.*?) /;
      var matchVariable = /{{([a-zA-Z]*)}}/;

      var matchFromExec = matchFrom.exec(str);
      if (typeof matchFromExec !== 'undefined' && matchFromExec !== null && typeof matchFromExec[1] !== 'undefined' && matchFromExec[1] !== null) {

        var fromMatch;
        var toReplace = matchFromExec[1];
        while (fromMatch = matchVariable.exec(toReplace)) {
          try {
            var value = eval('jsonPage.' + fromMatch[1]);
            if (typeof value !== 'undefined' && value !== null) {
              toReplace = toReplace.replace('{{' + fromMatch[1] + '}}', value);
            } else {
              toReplace = toReplace.replace('{{' + fromMatch[1] + '}}', '');
            }
          } catch (e) {
            console.log('cleanRequest error');
            console.log(e);
          }
        }

        str = str.replace(matchFromExec[1], toReplace);
      }

      var from = /from ([\S\s]+)/.exec(str);

      var matches = from;
      if (matches[1]) {
        var res = matches[1];
        var splitAttr = [' where ', ' order by ', ' limit ', ' WHERE ', ' ORDER BY ', ' LIMIT '];
        for (var i = 0; i < splitAttr.length; i++) {
          if (res.indexOf(splitAttr[i]) > -1) {
            res = res.substring(0, res.indexOf(splitAttr[i]));
          }
        }
        var escapedFrom = res.replace(/\//g, '___abe___');
        escapedFrom = escapedFrom.replace(/\./g, '___abe_dot___');
        escapedFrom = escapedFrom.replace(/-/g, '___abe_dash___');
        str = str.replace(res, escapedFrom);
      }

      str = str.replace(/``/g, '\'\'');

      return str;
    }
  }, {
    key: 'handleSqlRequest',
    value: function handleSqlRequest(str, jsonPage) {
      var cleanRequest = Sql.cleanRequest(str, jsonPage);
      var request = (0, _nodeSqlparser.parse)(cleanRequest);
      var reconstructSql = '';

      // SQL TYPE
      var type = '';
      if (typeof request.type !== 'undefined' && request.type !== null) {
        type = request.type;
      }
      reconstructSql += type + ' ';

      // SQL COLUMNS
      var columns = [];
      if (typeof request.columns !== 'undefined' && request.columns !== null) {
        if (request.columns === '*') {
          columns.push('*');
        } else {
          Array.prototype.forEach.call(request.columns, function (item) {
            columns.push(item.expr.column);
          });
        }
      }
      reconstructSql += JSON.stringify(columns) + ' ';

      // SQL FROM
      var from = [];
      if (typeof request.from !== 'undefined' && request.from !== null) {

        Array.prototype.forEach.call(request.from, function (item) {
          from.push(item.table);
        });
      } else {
        from.push('*');
      }
      reconstructSql += 'from ' + JSON.stringify(from) + ' ';

      var where;
      if (typeof request.where !== 'undefined' && request.where !== null) {
        where = request.where;
        // where = Sql.recurseWhere(request.where)
        // reconstructSql += 'where '
        // Array.prototype.forEach.call(where, (w) => {
        //   reconstructSql += `${w.operator} ${w.left} ${w.compare} ${w.right} `
        // })
      }

      var limit = -1;
      if (typeof request.limit !== 'undefined' && request.limit !== null) {
        limit = request.limit[request.limit.length - 1].value;
      }

      var orderby;
      if (typeof request.orderby !== 'undefined' && request.orderby !== null && request.orderby.length > 0) {
        orderby = {
          column: request.orderby[0].expr.column,
          type: request.orderby[0].type
        };
        reconstructSql += 'ORDER BY ' + orderby.column + ' ' + orderby.type + ' ';
      }

      return {
        type: type,
        columns: columns,
        from: from,
        where: where,
        string: reconstructSql,
        limit: limit,
        orderby: orderby
      };
    }
  }, {
    key: 'sortByDateDesc',
    value: function sortByDateDesc(a, b) {
      var dateA = new Date(a.date);
      var dateB = new Date(b.date);
      if (dateA < dateB) {
        return 1;
      } else if (dateA > dateB) {
        return -1;
      }
      return 0;
    }
  }, {
    key: 'shuffle',
    value: function shuffle(array) {
      var currentIndex = array.length,
          temporaryValue,
          randomIndex;

      // While there remain elements to shuffle...
      while (0 !== currentIndex) {

        // Pick a remaining element...
        randomIndex = Math.floor(Math.random() * currentIndex);
        currentIndex -= 1;

        // And swap it with the current element.
        temporaryValue = array[currentIndex];
        array[currentIndex] = array[randomIndex];
        array[randomIndex] = temporaryValue;
      }

      return array;
    }
  }, {
    key: 'sortByDateAsc',
    value: function sortByDateAsc(a, b) {
      var dateA = new Date(a.date);
      var dateB = new Date(b.date);
      if (dateA > dateB) {
        return 1;
      } else if (dateA < dateB) {
        return -1;
      }
      return 0;
    }
  }, {
    key: 'getDataSource',
    value: function getDataSource(str) {
      var res = str.substring(str.indexOf('source=') + 8, str.length);

      var reg = /([^'"]*=[\s\S]*?}})/g;
      var matches = res.match(reg);
      if (typeof matches !== 'undefined' && matches !== null) {
        Array.prototype.forEach.call(matches, function (match) {
          res = res.replace(match, '');
        });
      } else {
        res = res.replace('}}', '');
      }

      return res.substring(0, res.length - 1);
    }

    /**
     * replaces escaped characters with the right ones
     * @param  {String} statement the from clause
     * @return {String}           the from sanitized
     */

  }, {
    key: 'sanitizeFromStatement',
    value: function sanitizeFromStatement(statement) {
      var from = '';

      if (typeof statement !== 'undefined' && statement !== null) {
        from = statement[0].replace(/___abe_dot___/g, '.');
        from = from.replace(/___abe___/g, '/');
        from = from.replace(/___abe_dash___/g, '-');
      }

      return from;
    }

    /**
     * calculate the directory to analyze from the from clause
     * @param  {String} statement the from clause
     * @param  {String} tplPath   the path from the template originator
     * @return {string}           the directory to analyze
     */

  }, {
    key: 'getFromDirectory',
    value: function getFromDirectory(statement, tplPath) {
      var pathFromDir = '';
      if (typeof tplPath === 'undefined' || tplPath === null || tplPath === '') {
        tplPath = '/';
      }

      if (statement === '' || statement === '*' || statement === '/') {
        pathFromDir = _path2.default.join(_.config.root, _.config.data.url);
      } else if (statement === './') {
        pathFromDir = _path2.default.join(_.config.root, _.config.data.url, tplPath);
      } else if (statement.indexOf('/') === 0) {
        pathFromDir = _path2.default.join(_.config.root, _.config.data.url, statement);
      } else if (statement.indexOf('/') !== 0) {
        pathFromDir = _path2.default.join(_.config.root, _.config.data.url, tplPath, statement);
      }

      return pathFromDir;
    }
  }, {
    key: 'executeOrderByClause',
    value: function executeOrderByClause(files, orderby) {
      if (typeof orderby !== 'undefined' && orderby !== null) {
        if (orderby.column.toLowerCase() === 'random') {
          Sql.shuffle(files);
        } else if (orderby.column.toLowerCase() === 'date') {
          if (orderby.type === 'ASC') {
            files.sort(Sql.sortByDateAsc);
          } else if (orderby.type === 'DESC') {
            files.sort(Sql.sortByDateDesc);
          }
        }
      }

      return files;
    }
  }, {
    key: 'executeFromClause',
    value: function executeFromClause(statement, pathFromClause) {
      var from = Sql.sanitizeFromStatement(statement);

      // if the from clause ends with a dot, we won't recurse the directory analyze
      if (from.slice(-1) === '.') {
        from = from.slice(0, -1);
      }

      var fromDirectory = Sql.getFromDirectory(from, pathFromClause);

      var list = _.Manager.instance.getList();
      var files_array = list.filter(function (element, index) {
        if (element.publish) {
          if (element.path.indexOf(fromDirectory) > -1) {
            return true;
          }
        }
        return false;
      });
      return files_array;
    }
  }, {
    key: 'execQuery',
    value: function execQuery(pathQuery, match, jsonPage) {
      var res;
      var files;
      var request = Sql.handleSqlRequest((0, _.getAttr)(match, 'source'), jsonPage);

      files = Sql.executeFromClause(request.from, pathQuery);
      files = Sql.executeOrderByClause(files, request.orderby);
      res = Sql.executeWhereClause(files, request.where, request.limit, request.columns, jsonPage);

      return res;
    }
  }, {
    key: 'executeQuerySync',
    value: function executeQuerySync(pathQuerySync, match, jsonPage) {
      return Sql.execQuery(pathQuerySync, match, jsonPage);
    }
  }, {
    key: 'executeQuery',
    value: function executeQuery(pathexecuteQuery, match, jsonPage) {
      var p = new _es6Promise.Promise(function (resolve) {
        var res = Sql.execQuery(pathexecuteQuery, match, jsonPage);
        resolve(res);
      }).catch(function (e) {
        console.error(e);
      });

      return p;
    }

    /**
     * check if a given string an url, string json, file url, abe sql request
     * 
     * Sql.get('http://google.com')
     * Sql.get('{"test":"test"}')
     * Sql.get('select * from ../')
     * Sql.get('test')
     * 
     * @param  {String} str 
     * @return {String} url | request | value | file | other
     */

  }, {
    key: 'getSourceType',
    value: function getSourceType(str) {
      if (/http:\/\/|https:\/\//.test(str)) {
        return 'url';
      }

      if (/select[\S\s]*?from/.test(str)) {
        return 'request';
      }

      if (str !== '') {
        try {
          JSON.parse(str);
          return 'value';
        } catch (e) {
          console.log('getSourceType');
          console.log(str);
          console.log(e);
        }
      }

      if (/\.json/.test(str)) {
        return 'file';
      }

      return 'other';
    }
  }, {
    key: 'executeWhereClause',
    value: function executeWhereClause(files, wheres, maxLimit, columns, jsonPage) {
      var res = [];
      var limit = 0;

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = files[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var file = _step.value;

          if (limit < maxLimit || maxLimit === -1) {
            if (typeof wheres !== 'undefined' && wheres !== null) {

              if (!Sql.recurseWhere(wheres, file.publish, jsonPage)) {
                var json = JSON.parse(JSON.stringify(file.publish));
                var jsonValues = {};

                if (typeof columns !== 'undefined' && columns !== null && columns.length > 0 && columns[0] !== '*') {

                  Array.prototype.forEach.call(columns, function (column) {
                    if (typeof json[column] !== 'undefined' && json[column] !== null) {
                      jsonValues[column] = json[column];
                    }
                  });
                  jsonValues['abe_meta'] = json['abe_meta'];
                } else {
                  jsonValues = json;
                }

                res.push(jsonValues);
                limit++;
              }
            }
          } else {
            break;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return res;
    }
  }, {
    key: 'getWhereValuesToCompare',
    value: function getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc) {
      var regexIsVariable = /^{{(.*)}}$/;
      var value;
      var compare;

      try {
        value = eval('jsonDoc.' + where.left.column);
      } catch (e) {
        console.log('getWhereValuesToCompare:', e);
      }

      if (where.operator === 'IN' || where.operator === 'NOT IN') {

        compare = [];
        Array.prototype.forEach.call(where.right.value, function (right) {
          var matchVariable = regexIsVariable.exec(right.column);
          if (typeof matchVariable !== 'undefined' && matchVariable !== null && matchVariable.length > 0) {
            try {
              var jsonOriginalValues = eval('jsonOriginalDoc.' + matchVariable[1]);
              Array.prototype.forEach.call(jsonOriginalValues, function (jsonOriginalValue) {
                compare.push(eval('jsonOriginalValue.' + where.left.column));
              });
            } catch (e) {
              console.log('getWhereValuesToCompare:', e);
            }
          } else {
            compare.push(right.column);
          }
        });
      } else {
        compare = where.right.column;
        var matchVariable = regexIsVariable.exec(compare);

        if (typeof matchVariable !== 'undefined' && matchVariable !== null && matchVariable.length > 0) {
          try {
            var shouldCompare = eval('jsonOriginalDoc.' + matchVariable[1]);
            if (typeof shouldCompare !== 'undefined' && shouldCompare !== null) {
              compare = shouldCompare;
            } else {
              compare = null;
            }
          } catch (e) {
            compare = null;
            // console.log('e', e)
          }
        }
      }

      return {
        left: value,
        right: compare
      };
    }
  }, {
    key: 'recurseWhere',
    value: function recurseWhere(where, jsonDoc, jsonOriginalDoc) {
      var isNotLeftCorrect = false;
      var isNotRightCorrect = false;
      var isNotCorrect = false;
      var values;

      switch (where.operator) {
        case '=':
          values = Sql.getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc);
          if (values.left !== values.right) {
            isNotCorrect = true;
          }
          break;
        case '!=':
          values = Sql.getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc);
          if (values.left === values.right) {
            isNotCorrect = true;
          }
          break;
        case '>':
          values = Sql.getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc);
          isNotCorrect = values.left > values.right ? false : true;
          break;
        case '>=':
          values = Sql.getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc);
          isNotCorrect = values.left >= values.right ? false : true;
          break;
        case '<':
          values = Sql.getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc);
          isNotCorrect = values.left < values.right ? false : true;
          break;
        case '<=':
          values = Sql.getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc);
          isNotCorrect = values.left <= values.right ? false : true;
          break;
        case 'LIKE':
          values = Sql.getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc);
          if (values.left && values.left.indexOf(values.right) === -1) {
            isNotCorrect = true;
          }
          break;
        case 'NOT LIKE':
          values = Sql.getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc);
          if (values.left && values.left.indexOf(values.right) > -1) {
            isNotCorrect = true;
          }
          break;
        case 'AND':
          isNotLeftCorrect = Sql.recurseWhere(where.left, jsonDoc, jsonOriginalDoc);
          isNotRightCorrect = Sql.recurseWhere(where.right, jsonDoc, jsonOriginalDoc);
          isNotCorrect = isNotLeftCorrect || isNotRightCorrect ? true : false;
          break;
        case 'OR':
          isNotLeftCorrect = Sql.recurseWhere(where.left, jsonDoc, jsonOriginalDoc);
          isNotRightCorrect = Sql.recurseWhere(where.right, jsonDoc, jsonOriginalDoc);
          isNotCorrect = isNotLeftCorrect && isNotRightCorrect ? true : false;
          break;
        case 'IN':
          values = Sql.getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc);
          isNotCorrect = true;
          Array.prototype.forEach.call(values.right, function (right) {
            if (values.left === right) {
              isNotCorrect = false;
            }
          });
          break;
        case 'NOT IN':
          values = Sql.getWhereValuesToCompare(where, jsonDoc, jsonOriginalDoc);
          isNotCorrect = false;
          Array.prototype.forEach.call(values.right, function (right) {
            if (values.left === right) {
              isNotCorrect = true;
            }
          });
          break;
      }
      return isNotCorrect;
    }
  }]);

  return Sql;
}();

exports.default = Sql;