'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _ = require('../../');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FileParser = function () {
  function FileParser() {
    _classCallCheck(this, FileParser);
  }

  _createClass(FileParser, null, [{
    key: 'read',
    value: function read(base, dirName, type, flatten) {
      var extensions = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : /(.*?)/;
      var max = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 99;
      var current = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 0;
      var inversePattern = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : false;

      var arr = [];
      var level = _fsExtra2.default.readdirSync(dirName);
      var fileCurrentLevel = [];
      var assets = _.config.files.templates.assets;

      for (var i = 0; i < level.length; i++) {
        var pathLevel = dirName + '/' + level[i];
        var isFolder = true;
        try {
          var directory = _fsExtra2.default.lstatSync(pathLevel);
          if (!directory.isDirectory()) {
            isFolder = false;
          }
        } catch (e) {
          isFolder = false;
        }
        var match = isFolder ? true : inversePattern ? !extensions.test(level[i]) : extensions.test(level[i]);
        if ((type === 'files' || type === null) && match) {

          if (level[i].indexOf('.') > -1) {
            var extension = /(\.[\s\S]*)/.exec(level[i])[0];
            var cleanName = _.cmsData.fileAttr.delete(level[i]);
            var cleanNameNoExt = cleanName.replace(/\..+$/, '');
            var fileData = _.cmsData.fileAttr.get(level[i]);

            var date;
            if (fileData.d) {
              date = fileData.d;
            } else {
              var stat = _fsExtra2.default.statSync(pathLevel);
              date = stat.mtime;
            }
            var cleanFilePath = _.cmsData.fileAttr.delete(pathLevel).replace(_.config.root, '').replace(/^\/?.+?\//, '');

            var fileDate = (0, _moment2.default)(date);
            var duration = _moment2.default.duration((0, _moment2.default)(fileDate).diff(new Date())).humanize(true);

            var filePath = pathLevel.replace(_.config.root, '');
            filePath = filePath.split('/');
            filePath.shift();
            filePath = filePath.join('/');
            var item = {
              'name': level[i],
              'path': pathLevel,
              'cleanPathName': _.cmsData.fileAttr.delete(pathLevel),
              'cleanPath': pathLevel.replace(base + '/', ''),
              date: date,
              cleanDate: fileDate.format('YYYY/MM/DD HH:MM:ss'),
              duration: duration,
              cleanName: cleanName,
              cleanNameNoExt: cleanNameNoExt,
              cleanFilePath: cleanFilePath,
              filePath: filePath,
              'type': 'file',
              'fileType': extension
            };

            if (!flatten) item['folders'] = [];
            arr.push(item);
            // push current file name into array to check if siblings folder are assets folder
            fileCurrentLevel.push(level[i].replace(/\..+$/, '') + assets);
          }
        }
        if (!fileCurrentLevel.includes(level[i]) && match) {
          if (isFolder) {
            if (!flatten) {
              var index = arr.push({ 'name': level[i], 'path': pathLevel, 'cleanPath': pathLevel.replace(base + '/', ''), 'folders': [], 'type': 'folder' }) - 1;
              if (current < max) {
                arr[index].folders = FileParser.read(base, pathLevel, type, flatten, extensions, max, current + 1, inversePattern);
              }
            } else {
              if (type === 'folders' || type === null) {
                arr.push({ 'name': level[i], 'path': pathLevel, 'cleanPath': pathLevel.replace(base + '/', ''), 'type': 'folder' });
              }
              if (current < max) {
                Array.prototype.forEach.call(FileParser.read(base, pathLevel, type, flatten, extensions, max, current + 1, inversePattern), function (files) {
                  arr.push(files);
                });
              }
            }
          }
        }
      }

      return arr;
    }
  }, {
    key: 'getFolders',
    value: function getFolders(folder, flatten, level) {
      var arr = [];
      flatten = flatten || false;
      arr = FileParser.read(folder.replace(/\/$/, ''), folder.replace(/\/$/, ''), 'folders', flatten, /(.*?)/, level);
      return arr;
    }
  }, {
    key: 'getFiles',
    value: function getFiles(folder, flatten, level) {
      var extensions = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : /(.*?)/;
      var inversePattern = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;

      var arr = [];
      flatten = flatten || false;
      arr = FileParser.read(folder.replace(/\/$/, ''), folder.replace(/\/$/, ''), 'files', flatten, extensions, level, 0, inversePattern);

      return arr;
    }
  }, {
    key: 'getFilesByType',
    value: function getFilesByType(pathFile) {
      var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      try {
        var directory = _fsExtra2.default.lstatSync(pathFile);
        if (!directory.isDirectory()) {
          _mkdirp2.default.sync(pathFile);
        }
      } catch (e) {
        _mkdirp2.default.sync(pathFile);
      }
      var files = FileParser.getFiles(pathFile, true, 20, new RegExp('.' + _.config.files.templates.extension));

      var result = [];

      Array.prototype.forEach.call(files, function (file) {
        var val = _.cmsData.fileAttr.get(file.path).s;
        if (type === null || val === type) result.push(file);
      });
      return result;
    }
  }, {
    key: 'changePathEnv',
    value: function changePathEnv(pathEnv, change) {
      pathEnv = pathEnv.replace(_.config.root, '').replace(/^\//, '').split('/');
      pathEnv[0] = change;

      return _path2.default.join(_.config.root, pathEnv.join('/'));
    }

    /**
     * This function makes sorting on an array of Json objects possible.
     * Pass the property to be sorted on.
     * Usage: myArray.sort(FileParser.predicatBy('date',-1));
     * @param  String prop  the json property to sort on
     * @param  integer order order ASC if 1, DESC if -1
     * @return integer the ordered value
     */

  }, {
    key: 'predicatBy',
    value: function predicatBy(prop, order) {
      if (order !== -1) {
        order = 1;
      }
      if (prop === 'date') {
        return function (a, b) {
          a = new Date(a[prop]);
          b = new Date(b[prop]);
          if (a > b) {
            return 1 * order;
          } else if (a < b) {
            return -1 * order;
          }
          return 0;
        };
      }

      return function (a, b) {
        if (a[prop] > b[prop]) {
          return 1 * order;
        } else if (a[prop] < b[prop]) {
          return -1 * order;
        }
        return 0;
      };
    }
  }]);

  return FileParser;
}();

exports.default = FileParser;